/**Aufgabe1SiloLoesung04 <br>
 * <hr>
 * Fachklasse: <b> Silo </b>
 * 
 * <hr>
 * Aufgabe: Software fr Siloverwaltung
 * <hr>
 * @author R. Hoppe
 * @ version 1.1 vom 10.07.09
 */

public class Silo
{
    /**
     * Instanzvariablen
     */
    private int siloNr;
    private double kapazitaet; // in t
    private double bestand;    // in t
    
    /**<b> Konstruktur mit Parametern </b> <br>
     * Jedes Siloobjekt verlangt mindestens die Angabe der
     * siloNr und der kapazitt; die Kapazitt kann 
     * sich whrend der Lebensdauer eines Objektes nicht 
     * ndern; ein Wechsel der SiloNr ist grundstzlich mglich.
     * @param pSiloNr fr Instanzenvariable silonuNr
     * @param pKapazitaet fr Instanzenvariable kapazitaet
     */
    
    public Silo(int pSiloNr, double pKapazitaet)
    {
        siloNr = pSiloNr;
        kapazitaet =pKapazitaet;
        
    }
    
     /**<b> Konstruktur mit Parametern </b> <br>
     * Jedes Siloobjekt verlangt mindestens Werte fr die Instanzvariablen
     * siloNr und der kapazitt; die Kapazitt kann 
     * sich whrend der Lebensdauer eines Objektes nicht 
     * ndern; ein Wechsel der SiloNr ist grundstzlich mglich;
     * ist bei der Instanzierung eines Siloobjektes der akutelle Bestand
     * bekannt, kann dieser gleich ber den Parameter pBestand mit in
     * das Objekt geschrieben werden;
     * @param pSiloNr fr Instanzenvariable kontonummer;
     * @param pKapazitaet fr Instanzenvariable kapazitaet
     * @param pBestand fr Instanzvariable bestand
     */
    
     public Silo(int pSiloNr, double pKapazitaet, double pBestand)
    {
        siloNr = pSiloNr;
        kapazitaet =pKapazitaet;
        bestand = pBestand;
        
    }
    
    /**<b> Schreibende Methode </b> <br>
     * Die Nummer des Silos wird mit dieser Methode in das Siloobjekt geschrieben.
     * @param pSiloNr fr Instanzenvariable siloNr
     */
        
    public void setSiloNr(int pSiloNr){
      siloNr = pSiloNr;
    }
    
    /** <b> Lesende Methode <b> <br>
     *  Die Silonummer aus dem Siloobjekt wird an die aufrufenden Instanz bergeben. 
     *  @return siloNr
     */
    
    public int getSiloNr (){
     return siloNr;   
     }
     
    /**<b> Schreibende Methode </b> <br>
     * Die Kapazitt des Silos wird mit dieser Methode in das Siloobjekt geschrieben.
     * @param pKapazit fr Instanzenvariable Kapazitt.
     * Diese private Methode kann nur innerhalb dieser Klasse Silo Verwendung finden.
     */ 
    private void setKapazitaet (double pKapazitaet) {
        kapazitaet = pKapazitaet;
       
    }
    
    /** <b> Lesende Methode <b> <br>
     *  Die maximale Lagerkapazit des Silos aus dem Siloobjekt wird an die aufrufenden Instanz bergeben. 
     *  @return siloNr
     */
    public double getKapzitaet(){
        return kapazitaet;
       }

     /**<b> Schreibende Methode </b> <br>
     * Der akutelle im Silo lagernde Bestand wird mit dieser Methode in das Siloobjekt geschrieben.
     * @param pKapazit fr Instanzenvariable Kapazitt.
     */ 
    public void setBestand (double pBestand) {
        bestand = pBestand;
       
    } 
    
    /** <b> Lesende Methode <b> <br>
     *  Der akutelle Lagerbestand des Silos aus dem Siloobjekt wird an die aufrufenden Instanz bergeben. 
     *  @return bestand
     */
     
     public double getBestand(){
         return bestand;
        }
    
    /**<b> Funktionsmethode </b> <br>
     * Die Methode berechnet wie viel Tonnen noch in das Silo des Siloobjektes eingelagert werden knnen.
     * @retrun restmenge
     */
    public double ermittelnEinlagernRest(){
    double restmenge;
    restmenge = kapazitaet - bestand;
    return restmenge;
    }
    
    /**<b> Funktionsmethode </b> <br>
     * Die Methode ermittelt den Bestand im Silo, nachdem neue Mengen eingelagert werden.
     * @param pZugangsmenge fr die Instanzenvariable bestand.
     * @retrun meldung (als Information ber Erfolg oder Mierfolg der Einlagerungsaktion)
     */
    
    public String einlagern(double pZugangsmenge) {
       String meldung ="";
       double differenzmenge;
       differenzmenge = ermittelnEinlagernRest();
       
       if (differenzmenge>= pZugangsmenge){
           bestand = bestand + pZugangsmenge;
           meldung = "Einlagerung war erfolgreich";
          
        }
        
        else{
            meldung = "Einlagerung wegen Platzmangel im Silo nicht mglich.";

            
        }
            
       return meldung;
    }
    
    /**<b> Funktionsmethode </b> <br>
     * Die Methode ermittelt den Bestand im Silo, nachdem eine gegebene Menge ausgelagert wird.
     * @param pAbgangsmenge fr die Instanzenvariable bestand.
     * @return meldung (als Information ber Erfolg oder Mierfolg der Auslagerungsaktion)
     */
    
    public String auslagern(double pAbgangsmenge){
    String meldung = "";
  
    
     if (bestand >= pAbgangsmenge){
        bestand = bestand - pAbgangsmenge;
        meldung =" Auslagerung war erfolgreich.";
      
        }
        else{
        meldung = "Angeforderte Menge kann wegen eines zu geringen Bestandes im Silo nicht abgegeben werden.";

        }
    
     return meldung;
    }
    
    /**<b> Funktionsmethode </b> <br>
     * Die Methode ermittelt den Bestand in den Silos, nachdem eine gegebene Menge umgelagert wird;
     * die Methode ist stets an dem Siloobjekt aufzurufen, von dem das Getreide abgeht.
     * @param Zugangssiloobjekt
     * @param pMenge 
     * @return meldung (als Information ber Erfolg oder Mierfolg der Umlagerungsaktion)
     */
    
    public String umlagern( Silo zugangssilo, double pMenge){
    String meldung ="";
    double maxZugang;
    maxZugang = zugangssilo.ermittelnEinlagernRest();
   
    if (this.bestand >= pMenge && maxZugang >= pMenge  ) {
        this.auslagern(pMenge);
        zugangssilo.einlagern(pMenge);
        meldung = "Umlagern wurde erfolgreich abgeschlossen.";
      
    }
    else{
     meldung = "Umlagern nicht mglich, wegen Beschrnkungen im Abgangs- oder Zugangssilo.";
    }
    return meldung;
    }
       
    /** <b> Funktionsmethode </b> <br>
     * Die Methode errechnet nach bergabe des Schwundsatzes beim Trocken den neuen Bestand im Silo 
     * nach einem Trocknungsvorgang.
     * @param schwundSatz als Prozentsatz
     */
    public void trocknen(double schwundSatz){
        bestand = bestand * (100-schwundSatz)/100;
    }

    
}
